mlag <- function(X,lag){
  p <- lag
  X <- as.matrix(X)
  Traw <- nrow(X)
  N <- ncol(X)
  Xlag <- matrix(0,Traw,p*N)
  for (ii in 1:p){
    Xlag[(p+1):Traw,(N*(ii-1)+1):(N*ii)]=X[(p+1-ii):(Traw-ii),(1:N)]
  }
  return(Xlag)
}
get.pred <- function(zt=t(X[nrow(X),,drop=F]), laglen=laglen, m=m, K=K, At=At, SIGMA=SIGMA, fhorz=horz.fcst, Yraw.full=Y, Xraw.full=X, sl.joint=c(1,2,3)){
  get.comp <- get_companion(t(At),c(m,0,laglen))
  Mm <- get.comp$MM
  Jm <- get.comp$Jm
  
  z1 <- zt
  Mean00 <- zt
  Sigma00 <- matrix(0,K,K)
  Sigma00[1:m,1:m] <- SIGMA
  
  LPS.store <- matrix(NA,fhorz)
  LPS.marg.store <- matrix(NA,length(sl.joint),fhorz)
  pred.store <- matrix(NA,length(sl.joint),fhorz)
  for (ih in 1:fhorz){
    #Predict E(Y(t+n|t)) n=1,..,fhorz and compute cholesky factor of forecast error variance-covariance
    z1 <- Mm%*%z1
    cholSig <- try(t(chol(Sigma00[1:m,1:m])),silent=TRUE)
    if (is(cholSig, "try-error")){
      yf <- try(rmvnorm(1,z1[1:M],Sigma00[1:m,1:m]),silent=TRUE)
      if (is(yf,"try-error")) yf <- z1[1:m] #should be the option of last resort (happens in approx. 1 out of 100,000 cases)
    }else{
      yf <- z1[1:m]+cholSig%*%rnorm(m,0,1)
    }
    Mean00 <- Mm%*%Mean00
    Sigma00 <- Mm%*%Sigma00%*%t(Mm)+Jm%*%SIGMA%*%t(Jm)
    meanyt <- Mean00[1:m]
    varyt <- Sigma00[1:m,1:m]
    # sl.forecast <- nrow(Xraw.full)-hold.out+h.out-1+ih
    # if (sl.forecast>nrow(Xraw.full)) next
    # LPS.store[ih] <- mvtnorm::dmvnorm(Yraw.full[sl.forecast,sl.joint],meanyt[sl.joint],varyt[sl.joint, sl.joint],log=TRUE)
    # LPS.marg.store[,ih] <- dnorm(Yraw.full[sl.forecast,sl.joint], meanyt[sl.joint], sqrt(diag(varyt[sl.joint, sl.joint])),log=TRUE)
    pred.store[,ih] <- yf[sl.joint]
  }
  
  pred.list <- list(yhat=pred.store, LPS=LPS.store, LPS.marg=LPS.marg.store)
  return(pred.list)
}


norm_vec <- function(x) sqrt(sum(x^2))

sparsify <- function(X,b,K.max,nu){
  b.sparse <- matrix(0,K.max,1)
  for (jj in seq_len(K.max)){
    mu.jj <- 1/abs(b[jj,1])^nu
    norm.j <- norm_vec(X[,jj])^2
    if ((abs(b[jj,1])*norm.j) < mu.jj){
      b.sparse[jj,1] <- 0
    }else{
      b.sparse[jj,1] <- sign(b[jj,1])* 1/norm.j * ((abs(b[jj,1])*norm.j)-mu.jj)
    }
  }
  return(b.sparse)
}

get_companion <- function(Beta_,varndxv){
  nn <- varndxv[[1]]
  nd <- varndxv[[2]]
  nl <- varndxv[[3]]
  
  nkk <- nn*nl+nd
  Jm <- matrix(0,nkk,nn)
  MM <- matrix(0,nkk,nkk)
  Jm[1:nn,1:nn] <- diag(nn)
  if (nd==1){
    MM <- rbind(t(Beta_), cbind(diag((nl-1)*nn),matrix(0,(nl-1)*nn,nn+nd)),c(matrix(0,nd,nn*nl),nd))
  }else{
    MM <- rbind(t(Beta_), cbind(diag((nl-1)*nn),matrix(0,(nl-1)*nn,nn+nd)))
  }
  return(list(MM=MM,Jm=Jm))
}


